/*****************************************************************************
 *   Copyright (C) 2011 Christian "Cebra" Brandtner, brandtner@brandtner.net *
 *                                                                           *
 *   This program is free software; you can redistribute it and/or modify    *
 *   it under the terms of the GNU General Public License as published by    *
 *   the Free Software Foundation; either version 2 of the License.          *
 *                                                                           *
 *   This program is distributed in the hope that it will be useful,         *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           *
 *   GNU General Public License for more details.                            *
 *                                                                           *
 *   You should have received a copy of the GNU General Public License       *
 *   along with this program; if not, write to the                           *
 *   Free Software Foundation, Inc.,                                         *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.               *
 *                                                                           *
 *****************************************************************************/

/*
 * Hal_HW1_2.h
 *
 *  Created on: 13.07.2011
 *      Author: cebra
 * Hardwareabhängige Definitionen und Prozeduren
 * Hardware Leiterplatte V1.2 sebseb7
 *
 */

/* Belegung der Ports*/
/*Hardware 1.2 sebseb7 Portbelegung

Servo                   PD4    Pin 13
Servo 					PD5    Pin 14
Displaybeleuchtung     	PD7    Pin 16        LED an +
Displaybeleuchtung      PC0    Pin 10        LED an +
Displaybeleuchtung      PC1    Pin 20        LED an +
Summer            		PC6    Pin 25        Summer an GND

*/





#ifndef HAL_HW1_2_H_
#define HAL_HW1_2_H_

#define set_cs()    (PORTB |=  (1 << PB4))			// Display
#define clr_cs()    (PORTB &= ~(1 << PB4))
#define set_reset() (PORTB |=  (1 << PB2))
#define clr_reset() (PORTB &= ~(1 << PB2))
#define set_A0()    (PORTB |=  (1 << PB3))			// Data
#define clr_A0()    (PORTB &= ~(1 << PB3))			// Command
#define set_scl()   (PORTB |=  (1 << PB7))
#define clr_scl()   (PORTB &= ~(1 << PB7))
#define set_si()    (PORTB |=  (1 << PB5))
#define clr_si()    (PORTB &= ~(1 << PB5))

#define set_LED1()	(PORTC &= ~(1 << PC3))			// Leds
#define clr_LED1()	(PORTC |=  (1 << PC3))
#define set_LED2()	(PORTC &= ~(1 << PC2))
#define clr_LED2()	(PORTC |=  (1 << PC2))
#define set_LED3()	(PORTB &= ~(1 << PB1))
#define clr_LED3()	(PORTB |=  (1 << PB1))
#define set_LED4()	(PORTB &= ~(1 << PB0))
#define clr_LED4()	(PORTB |=  (1 << PB0))


#define clr_BEEP()	(PORTC &= ~(1 << PC6))			//Summer
#define set_BEEP()	(PORTC |=  (1 << PC6))

#define set_WI232CMD()	(PORTD &= ~(1 << PD6))
#define clr_WI232CMD()	(PORTD |=  (1 << PD6))


#define KEY_PIN			PINA

#define KEY_ENTER		PA7
#define KEY_ESC			PA6
#define KEY_PLUS		PA5
#define KEY_MINUS		PA4

void set_D_LIGHT(void);	/* Displaybeleuchtung ein*/
void clr_D_LIGHT(void);	/* Displaybeleuchtung aus*/

void InitHWPorts(void);

#endif /* HAL_HW1_2_H_ */
