/*****************************************************************************
 *   Copyright (C) 2011 Christian "Cebra" Brandtner, brandtner@brandtner.net *
 *                                                                           *
 *   This program is free software; you can redistribute it and/or modify    *
 *   it under the terms of the GNU General Public License as published by    *
 *   the Free Software Foundation; either version 2 of the License.          *
 *                                                                           *
 *   This program is distributed in the hope that it will be useful,         *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           *
 *   GNU General Public License for more details.                            *
 *                                                                           *
 *   You should have received a copy of the GNU General Public License       *
 *   along with this program; if not, write to the                           *
 *   Free Software Foundation, Inc.,                                         *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.               *
 *                                                                           *
 *****************************************************************************/

/*
 * Hal_HW3_9.h
 *
 *  Created on: 13.07.2011
 *  	Author: cebra
 * Hardwareabhängige Definitionen und Prozeduren
 * Hardware Leiterplatte V3.2 Cebra
 * USB,Wi232,LED
 */

/*Hardware 3.9 Portbelegung*/

#define	Touch0				PA0
#define	Touch1				PA1
#define	Touch2				PA2
#define	Touch3				PA3


#define KEY_ENTER		Key1
#define KEY_ESC			Key2
#define KEY_PLUS		Key3
#define KEY_MINUS		Key4

#define	Key1				PA4
#define	Key2				PA5
#define	Key3				PA6
#define	Key4				PA7
//........................................................//
#define	USB2Wi				PB0	//Pin	40	aktiv low
#define	VoltageHold			PB1	//Pin	41	Spannung mit T3 halten
#define	Display_Reset		PB2
#define	Display_A0			PB3
#define	Display_CS			PB4
#define	Display_SI			PB5

#define	LED1      			PB6	//Pin	2	LED an +

#define	Display_SCL			PB7
//........................................................//
#define	I2C_SCL				PC0	//Pin	19	SCL
#define	I2C_CDA				PC1	//Pin	20	SDA

#define	USB2FC				PC2	//Pin	21	aktiv low
#define	USB_BT         		PC3	//Pin	22	high = USB, Low = Bluetooth, LED2
#define	LowBat				PC4	//Pin	23	Low Bat Warning Lipo PKT,Input
#define	Uart02Wi			PC5	//Pin	24	aktiv low
#define	Uart02FC			PC6	//Pin	25	aktiv low
#define	Summer          	PC7	//Pin	26	Summer an +
//........................................................//
#define	Uart0RxD			PD0
#define	Uart0TxD			PD1
#define	Uart1RxD			PD2
#define	Uart1TxD			PD3

#define	Servo1           	PD4	//Pin	13	PWM
#define	Servo2 				PD5	//Pin	14	PWM
#define	Wi232_CMD			PD6	//Pin	15	aktiv low
#define	Displaybeleuchtung	PD7	//Pin	16	LED an +

#define Uart12USB			0xFA

#ifndef HAL_HW3_9_H_
#define HAL_HW3_9_H_



#define set_reset() (PORTB |=  (1 << Display_Reset))
#define clr_reset() (PORTB &= ~(1 << Display_Reset))
#define set_A0()    (PORTB |=  (1 << Display_A0))
#define clr_A0()    (PORTB &= ~(1 << Display_A0))
#define set_cs()    (PORTB |=  (1 << Display_CS))
#define clr_cs()    (PORTB &= ~(1 << Display_CS))
#define set_si()    (PORTB |=  (1 << Display_SI))
#define clr_si()    (PORTB &= ~(1 << Display_SI))
#define set_scl()   (PORTB |=  (1 << Display_SCL))
#define clr_scl()   (PORTB &= ~(1 << Display_SCL))

#define set_LED1()  (PORTB &= ~(1 << LED1))
#define clr_LED1()  (PORTB |=  (1 << LED1))				//Led1

#define set_BTOn()	(PORTC &= ~(1 << USB_BT))			// Bluetooth ein
#define set_USBOn()	(PORTC |=  (1 << USB_BT))			// USB ein

#define set_USB2FC()(PORTC &= ~(1 << USB2FC))			// USB mit FC SV2 verbinden
#define clr_USB2FC()(PORTC |=  (1 << USB2FC))

#define clr_V_On()	(PORTB &= ~(1 << VoltageHold))		// Spannung mit T3 halten
#define set_V_On()	(PORTB |=  (1 << VoltageHold))

#define set_USB2Wi()(PORTB &= ~(1 << USB2Wi))			// USB mit Wi232 verbinden
#define clr_USB2Wi()(PORTB |=  (1 << USB2Wi))

#define set_Uart02Wi()(PORTC &= ~(1 << Uart02Wi))		//Uart0 mit Wi232 verbinden
#define clr_Uart02Wi()(PORTC |=  (1 << Uart02Wi))

#define set_Uart02FC()(PORTC &= ~(1 << Uart02FC))		//Uart0 mit FC SV2 verbinden
#define clr_Uart02FC()(PORTC |=  (1 << Uart02FC))

#define clr_Uart02USB()(PORTC &= ~(1 << Uart02FC))		//Uart0 mit FC SV2 verbinden
#define set_Uart02USB()(PORTC |=  (1 << Uart02FC))

#define set_BEEP()	(PORTC &= ~(1 << Summer))			//Summer
#define clr_BEEP()	(PORTC |=  (1 << Summer))


#define set_D_LIGHT()	(PORTD |= (1 << Displaybeleuchtung))		/* Displaybeleuchtung*/
#define clr_D_LIGHT()	(PORTD &= ~(1 << Displaybeleuchtung))
#define set_WI232CMD()	(PORTD &= ~(1 << Wi232_CMD))				/* Wi232 Programmierpin*/
#define clr_WI232CMD()	(PORTD |=  (1 << Wi232_CMD))


#define KEY_PIN			PINA

//#define KEY_ENTER		Key4
//#define KEY_ESC			Key3
//#define KEY_PLUS		Key2
//#define KEY_MINUS		Key1


void InitHWPorts(void);

void Change_Output(uint8_t UartMode);	/* Schaltet die Rx/Tx Richtungen*/
void Port_USB2Wi(void);
void Port_USB2FC(void);
void Port_USB2_CFGWi(void);
void Port_BT2Wi(void);
void Port_BT2FC(void);


#endif /* HAL_HW3_9_H_ */
